//
//  Local_TeX.m
//  Local TeX
//
//  Created by Richard Koch on 2/21/14.
//  Copyright (c) 2014 Richard Koch. All rights reserved.
//

#import "Local_TeX.h"

@implementation Local_TeX

- (void)mainViewDidLoad
{
    NSFileManager *myFileManager;
    NSString      *texPath;
    BOOL          fileExists, directoryExists;
    
    myFileManager = [NSFileManager defaultManager];
    
    // Create ~/Library/TeX if necessary
    texPath = [@"~/Library/TeX" stringByExpandingTildeInPath];
    fileExists = [myFileManager fileExistsAtPath: texPath isDirectory: &directoryExists];
    if ((fileExists) && (! directoryExists)) {
        [myTableControl errorTeXDirectory];
        return; // put up error message
    }
    if ( ! fileExists) {
        [myFileManager createDirectoryAtPath:texPath withIntermediateDirectories: NO attributes:nil error: NULL];
    }
    
    // Fill tha table with data
    [myTableControl registerForDrags];
    [myTableControl fillTable];
}

@end
