//
//  RemoveDistTable.m
//  Local TeX
//
//  Created by Richard Koch on 2/16/14.
//  Copyright (c) 2014 Richard Koch. All rights reserved.
//

#import <CoreServices/CoreServices.h>
#import "RemoveDistTable.h"

@implementation RemoveDistTable

- (void)setupTable
{
    self.selectedRow = -1;
    self.changed = NO;
    self.selectedItemWasRemoved = YES;
    [theExtrasTable reloadData];
}

- (NSInteger)numberOfRowsInTableView:(NSTableView *)aTableView
{
    return [[myLTModel.extrasDictionary objectForKey:@"MoreDists"] count];
}


- (NSView *)tableView:(NSTableView *)tableView
   viewForTableColumn:(NSTableColumn *)tableColumn
                  row:(NSInteger)row
    {
    NSTableCellView *result;
    NSDictionary *theItem;
    NSString *theName;
    
    // Retrieve to get the @"MyView" from the pool or,
    // if no version is available in the pool, load the Interface Builder version
    
    // Set the stringValue of the cell's text field to the nameArray value at row
    //   if ([tableColumn.identifier isEqualToString: @"First"])
 
    theItem = [[myLTModel.extrasDictionary objectForKey:@"MoreDists"] objectAtIndex: row];
    
    result = [tableView makeViewWithIdentifier:@"MyExtraDistribution" owner:self];
    theName = [theItem objectForKey: @"MoreName"];
    result.textField.stringValue = theName;
    
    return result;
    }




- (void)tableViewSelectionDidChange:(NSNotification *)aNotification;
{
    self.selectedRow = [theExtrasTable selectedRow];
    if (self.selectedRow < 0)
        {
        self.selectedItemWasRemoved = YES;
            [removeButton setEnabled:NO];
        }
    else
        {
        self.selectedItemWasRemoved = NO;
            [removeButton setEnabled:YES];
        }
 }



- (void)runRemoveDistributionPanel;
    {
        [self setupTable];
        [NSApp beginSheet:removeDistributionPanel
           modalForWindow:[theRegularTable window]
            modalDelegate:self
           didEndSelector:nil
              contextInfo:nil];
    }


- (IBAction)closeDialogPushed:(id)sender
{
    [NSApp endSheet: removeDistributionPanel];
    [removeDistributionPanel orderOut:sender];
    // if changed, display main table
    if (self.changed)
      [theRegularTable reloadData];
}

- (IBAction)removeSelectedCellPushed:(id)sender
{
    NSDictionary    *theItem;
    NSString        *theName;
    
    if (! self.selectedItemWasRemoved)
    {
        self.changed = YES;
        
        // remove the item from the extrasDictionary
        // recalculate the data for this table
        // redisplay the table
        theItem = [[myLTModel.extrasDictionary objectForKey:@"MoreDists"] objectAtIndex: self.selectedRow];
        theName = [theItem objectForKey:@"MoreName"];
        [myLTModel removeExtraDistributionWithName:theName];
        [myLTModel setupData];
        [theExtrasTable reloadData];
    }
}



@end
