//
//  TableControl.h
//  Local TeX
//
//  Created by Richard Koch on 2/16/14.
//  Copyright (c) 2014 Richard Koch. All rights reserved.
//

// We create a Mutable Array of NSDictionaries. Each dictionary has  items,

//      Key                 Item
//      Active64            BOOL = YES for 64 bit, NO for 32 bit
//      PathTo32            Full Path to universal-darwin or null
//      PathTo64            Full Path to x86_64-darwub or null
//      PathToDist          Full Path to Distribution
//      Name                Name of Distribution

// We also create a dictionary containing
//
//      Key                 Item
//      ActiveName          Name of Active Distribution
//      MoreDists           Array of Other Distributions
//
// Here the structure of MoreDists is
//
//      Key                 Item
//      MoreName            Name of Distribution
//      MoreDistribution    Full Path To Distribution
//      MoreBinary          Full Path To Binary

#import <Foundation/Foundation.h>
#import "LTModel.h"
#import "RemoveDistTable.h"



@interface TableControl : NSObject
{
    
    IBOutlet LTModel            *myLTModel;
    IBOutlet RemoveDistTable    *myRemoveDistTable;
    IBOutlet NSTableView        *theTable;
    IBOutlet NSPanel            *newDistributionPanel;
    IBOutlet NSTextField        *distributionName;
    IBOutlet NSTextField        *distributionPath;
    IBOutlet NSTextField        *binaryPath;

}

@property BOOL loaded;

- (NSInteger)numberOfRowsInTableView:(NSTableView *)aTableView;

- (NSView *)tableView:(NSTableView *)tableView viewForTableColumn:(NSTableColumn *)tableColumn
                  row:(NSInteger)row;

- (void)tableViewSelectionDidChange:(NSNotification *)aNotification;

- (void)fillTable;

- (void)errorTeXDirectory;

- (void)errorBinaryDirectory;

- (void)registerForDrags;

@end
