#!/usr/bin/env ruby

raise "Not a standalone command" if __FILE__ == $0

module TeXDist
    class Application
        class Options
            attr_accessor :index
        end
        class Parser
            def my_content(options)
                separator('Usage:')
                separator("    #{$me} delete [Options] -> delete a bridge")
                separator('Options:')
                on('-b','--bridge DISTRIBUTION','will be deleted.'){|x| options.distribution=x}
                on('-i','--index i','Delete the ith bridge in the list.'){|n| n=n.to_i;options.index=n>0?n-1:n}
                separator('One of these two options is required.')
                separator('Paths to bridges are accepted in the former.')
                separator('The ith bridge from the end is obtained with the negative index -i.')
                on('-s','--simulate','simulate deletion'){options.simul8=true}
            end
        end
        def should_proceed?
            if setup_option_bridge
                base=bridge.base_p.my_realpath
                root=bridge.root_p.my_realpath
                @bridges.select do |b| !b.user_domain and b!=bridge end.each do |b|
                    return true if b.available_archs.empty?
                    return true if b.root_p.my_realpath == root and b.base_p.my_realpath == base
                end
                my_puts('This is the only bridge to the distribution, no deletion.')
            else
                my_puts('Missing distribution, nothing to delete.')
            end
            false
        end
        def proceed
            if simul8?
                my_puts "Delete #{bridge.path}."
            else
                my_log "Delete #{bridge.path}.", 3
                FileUtils.remove_entry_secure(bridge.path.to_s)
            end
            0
        end
    end
end
