#!/usr/bin/env ruby

raise "Not a standalone command" if __FILE__ == $0

module TeXDist
    class Application
        class Options
            attr_accessor :distributions,:indices
        end
        class Parser
            def my_content(options)
                separator('Usage:')
                separator("    #{$me} upgrade [Options] -> upgrade bridges to the latest version (aka #{Helper.version})")
                separator('Options:')
                on('-d','--distribution DISTRIBUTION','upgrade DISTRIBUTION bridge'){|x| options.distributions<<x}
                on('-i','--index i','upgrade the ith bridge in the list.'){|i| i.split(',').each{|n| n=n.to_i;n=n>0?n-1:n;options.indices<<n}}
                separator('When neither an index or a name is given, the active distribution takes place.')
                separator('Paths to bridges are accepted in the former as well as the wildcard "*".')
                separator('It can be used more than once.')
                separator('The latter accepts comma separated lists of indices and can be used more than once too.')
                separator('The ith bridge from the end is obtained with the negative index -i.')
                on('-s','--simulate','simulate conversion'){options.simul8=true}
            end
        end
        def preprocess?
            @options.distributions=[]
            @options.indices=[]
            true
        end
        def should_proceed?
            option_bridges.count>0
        end
        def proceed
            require_relative '../helper.rb'
            option_bridges.each do |b|
                (b.version=Helper.version;my_log(name+' converted',5)) if b.version < Helper.version and Helper.upgrade(b.path,simul8?) and not simul8?
            end
            0
        end
    end
end
