#!/usr/bin/env ruby

raise "Not a standalone command" if __FILE__ == $0

require 'pathname'
require 'fileutils'

$REL_PATH_REP='Library/TeX/Distributions'
$REL_PATH_EXES='Library/PreferencePanes/TeXDist2.prefPane/Contents/Executables'
$EXT='.texdist'

class Pathname
    @@my_root=Pathname.new('/')
    @@my_local_repository=@@my_root+$REL_PATH_REP
    @@my_home=Pathname.new('~').expand_path
    @@my_user_repository=@@my_home+$REL_PATH_REP
    def Pathname.my_home
        @@my_home
    end
    def Pathname.my_root(user_domain=false)
        user_domain ?@@my_home:@@my_root
    end
    def Pathname.my_repository(user_domain=false)
        user_domain ?@@my_user_repository:@@my_local_repository
    end
    def Pathname.my_default_contents(user_domain=false)
        my_repository(user_domain)+'.DefaultTeX'+'Contents'
    end
    def Pathname.my_default_texbin(user_domain=false)
        my_default_contents(user_domain).my_programs.my_texbin
    end
    def Pathname.my_usr_texbin(user_domain=false)
        p=user_domain ? @@my_user_repository:@@my_root
        p.my_usr.my_texbin
    end
    def Pathname.my_Library_texbin(user_domain=false)
        p=user_domain ? @@my_user_repository:@@my_local_repository
        p.my_programs.my_texbin
    end
    def Pathname.my_Library_texbin_destination(user_domain=false)
        my_default_contents(user_domain=false).my_programs.my_texbin
    end
    def Pathname.my_Library_me_destination(user_domain=false)
        p=user_domain ? @@my_home:@@my_root
        (p+$REL_PATH_EXES).my_me
    end
    def Pathname.my_usr_texbin_destination(user_domain=false)
        my_repository(user_domain).my_programs.my_texbin
    end
    def Pathname.my_each_volume
        r=[new('/')]
        d=new('/Volumes')
        d.each_child{|v| r<<(v) if not v.symlink? and v.directory? } if d.directory?
        r.each{|v| yield(v) if block_given?}
    end
    def Pathname.get_my_default_contents(user_domain=false)
        d=my_default_contents(user_domain)
        if d.symlink?
            r=d.readlink
            return r.absolute? ? r : d.parent+r
        end
        nil
    end
    def Pathname.set_my_default_contents(bridge,user_domain=false,simul8=false)
        my_default_contents(user_domain).my_make_symlink(bridge.path.my_contents_destination(user_domain),simul8)
    end
    def my_vodoba
        v,r=my_vorel
        d,b=r.my_doba
        return v,d,b
    end
    def my_doba
        b=Pathname.new('.')
        if absolute?
            d=@@my_root
        else
            d=b
        end
        e=each_filename
        def e.my_end?
            self.peek
            false
        rescue StopIteration
            true
        end
        while not e.my_end? and e.peek!='Library'
            d=d+e.next
        end
        while not e.my_end?
            b=b+e.next
        end
        return d,b
    end
    def my_vorel
        v=Pathname.new('.')
        r=self
        if absolute?
            v=@@my_root
            r=Pathname.new('.')
            e=each_filename
            def e.my_end?
                self.peek
                false
            rescue StopIteration
                true
            end
            begin
                if e.peek=='Volumes'
                    v=(v+e.next)+e.next
                end
                rescue StopIteration
            end
            while not e.my_end?
                r=r+e.next
            end
        end
        return v,r
    end
    def my_startup?
        to_s=='/'
    end
    def my_realpath
        begin
            realpath
        rescue Errno::ENOENT
            self
        rescue Errno::EACCES
            self
        end
    end
    def my_volume
        if absolute?
            p=@@my_root
            e=each_filename
            begin
                p=p+'Volumes'+e.next if e.next=='Volumes'
            rescue StopIteration
                p
            end
        else
            nil
        end
    end
    def bridges_repository(factory=false)
        p=self+$REL_PATH_REP
        factory ? p+'.FactoryDefaults':p
    end
    def each_bridge_name(with_ext=true,factory=false)
        d=bridges_repository(factory)
        d.directory? ? d.each_child(true).select{|n| n.my_match_ext?(with_ext)}.each{|n| yield(n) if block_given?}:[]
    end
    def my_exec(simul8,message,level,&block)
        simul8 ? my_puts(message): (my_log message,level;yield block)
        true
    end
    def my_mkpath(simul8=false)
        exist? or my_exec simul8, "Create #{self}", 3 do mkpath end
    end
    def my_make_relative_symlink(destination,simul8=false)
        my_make_symlink(destination.relative_path_from(parent),simul8)
    end
    def my_make_symlink(destination,simul8=false)
        my_force_delete(simul8)
        parent.my_mkpath(simul8)
        my_exec simul8,"symlink #{self} -> #{destination}",3 do make_symlink(destination) end
    end
    def my_match?(name)
        return true if name+'.X'==(self+'.X').to_s
        name = name.to_s
        my_corename.to_s==name or basename.to_s==name or to_s==name or fnmatch?(name)
    end
    def my_match_ext?(with_ext=true)
        not with_ext or fnmatch?('**'+$EXT)
    end
    def my_force_delete(simul8=false)
        my_rmdir_rf?(simul8) or ((exist? or symlink?) and my_exec simul8,"Delete #{self}",3 do delete end)
    end
    def my_rmdir_rf?(simul8=false)
        directory? and not symlink? and my_exec(simul8,"rm -Rf #{self}",3) do FileUtils.rm_rf(to_s) end
    end
    def my_rename(new_name,simul8=false)
        my_exec simul8,"Rename #{self} to #{new_name}",3 do rename(new_name) end
    end
    def my_corename
        self.basename.sub_ext('')
    end
    def my_contents
        self+'Contents'
    end
    def my_contents_destination(user_domain=false)
        my_contents.each_filename do |component|
            return component !='Volumes' ? self.my_contents.relative_path_from(Pathname.my_default_contents(user_domain).parent): nil
        end
    end
    def my_version
        my_contents+'TeXDistVersion'
    end
    def my_root
        self+'Root'
    end
    def my_base
        self+'Base'
    end
    def my_programs
        self+'Programs'
    end
    def my_me
        self+'texdistmgr'
    end
    def my_distributions
        self+'Distributions'
    end
    def my_usr
        self+'usr'
    end
    def my_texbin
        self+'texbin'
    end
    def my_badistro
        b=d=r=Pathname.new('.')
        each_filename.drop_while do |c|
            c=='..' and (b=b+c;true)
        end.drop_while do |c|
            not c.match(/(?<!\d)20\d\d(?!\d)/) and (d=d+c;true)
        end.each do |c|
            r=r+c
        end
        return b,d,r
    end
    def my_relative_path_from(p,no_up=true)
        r=self.relative_path_from(p)
        if no_up
            r.descend do |c|
                return c.to_s!='..' ? r : nil
            end
        end
        r
    rescue
        nil
    end
    def my_print_symlink_info
        print "#{self} -> #{self.readlink}\n"
    rescue
        print "#{self} -> ???\n"
    end
    def Pathname.my_print_texbin_info
        my_usr_texbin(false).my_print_symlink_info
        my_Library_texbin(false).my_print_symlink_info
        my_default_contents(false).my_print_symlink_info
        my_default_texbin(false).my_print_symlink_info
        my_Library_texbin(true).my_print_symlink_info
        my_default_contents(true).my_print_symlink_info
        my_default_texbin(true).my_print_symlink_info
    end
    def Pathname.my_fix_texbin(user_domain=false,simul8=false)
        my_usr_texbin(user_domain).my_make_relative_symlink(my_usr_texbin_destination(user_domain),simul8) unless user_domain
        my_Library_texbin(user_domain).my_make_relative_symlink(my_Library_texbin_destination(user_domain),simul8)
    end
    def Pathname.my_fix_me(user_domain=false,simul8=false)
        my_repository(user_domain).my_programs.my_me.my_make_relative_symlink(my_Library_me_destination(user_domain),simul8)
    end
end
