#!/usr/bin/env ruby

raise "Not a standalone command" if __FILE__ == $0

require 'test/unit'

module TeXDist
    class Application
        class TestBridge < Test::Unit::TestCase
            def my_bridge(p,yorn=true)
                b=Bridge.nouveau(Pathname.new(p))
                assert yorn != b.nil?,(yorn ? "#{b} expected not nil":"#{b} expected nil")
                b
            end
            def test_definition
                p=Pathname.new('/XLibrary/TeX/Distributions/a.texdist')
                b=Bridge.nouveau(p,true,true)
                assert b.nil?, "Unexpected b at #{p}"
                p=Pathname.new('/Library/TeX/Distributions/a.texdist')
                b=Bridge.nouveau(p,true,false)
                assert ! b.nil?, "Expected b at #{p}"
                assert b.volume.to_s=="/","Expected volume #{p}->/"
                assert b.domain.to_s==".","Expected domain #{p}->."
                assert b.base_path.to_s=="Library/TeX/Distributions/a.texdist","Expected base path #{p}->Library/TeX/Distributions/a.texdist"
                p=Pathname.new('/Users/me/Library/TeX/Distributions/a.texdist')
                b=Bridge.nouveau(p,true,false)
                assert ! b.nil?, "Expected b at #{p}"
                assert b.volume.to_s=="/","Expected volume #{p}->/"
                assert b.domain.to_s=="Users/me","Expected domain #{p}->Users/me"
                assert b.base_path.to_s=="Library/TeX/Distributions/a.texdist","Expected base path #{p}->Library/TeX/Distributions/a.texdist"
                p=Pathname.new('/Volumes/V/Library/TeX/Distributions/a.texdist')
                b=Bridge.nouveau(p,true,false)
                assert ! b.nil?, "Expected b at #{p}"
                assert b.volume.to_s=="/Volumes/V","Expected volume #{p}->/Volumes/V"
                assert b.domain.to_s==".","Expected domain #{p}->."
                assert b.base_path.to_s=="Library/TeX/Distributions/a.texdist","Expected base path #{p}->Library/TeX/Distributions/a.texdist"
                p=Pathname.new('/Volumes/V/Users/Me/Library/TeX/Distributions/a.texdist')
                b=Bridge.nouveau(p,true,false)
                assert ! b.nil?, "Expected b at #{p}"
                assert b.volume.to_s=="/Volumes/V","Expected volume #{p}->/Volumes/V"
                assert b.domain.to_s=="Users/Me","Expected domain #{p}->Users/Me"
                assert b.base_path.to_s=="Library/TeX/Distributions/a.texdist","Expected base path #{p}->Library/TeX/Distributions/a.texdist"
            end
            def test_comparison
                b1=my_bridge('/Library/TeX/Distributions/Fink-teTeX.texdist')
                b2=my_bridge('/Library/TeX/Distributions/gwTeX-2003-2005.texdist')
                b3=my_bridge('/Library/TeX/Distributions/MacPorts-teTeX.texdist')
                b4=my_bridge('/Library/TeX/Distributions/MacPorts-TeXLive.texdist')
                b6=my_bridge('/Library/TeX/Distributions/TeXLive-2010.texdist')
                b11=my_bridge('/Library/TeX/Distributions/TeXLive-2011.texdist')
                b8=my_bridge('/Library/TeX/Distributions/TeXLive-2012.texdist')
                b10=my_bridge('/Library/TeX/Distributions/TeXLive-2013.texdist')

                b5=my_bridge('/Library/TeX/Distributions/TeXLive-2010-64.texdist')
                b7=my_bridge('/Users/itexmac2/Library/TeX/Distributions/TeXLive-2012.texdist')
                b9=my_bridge('/Library/TeX/Distributions/TeXLive-2013-copy.texdist')
                b12=my_bridge('/Library/TeX/Distributions/TeXLive-dev.texdist')
                b13=my_bridge('/Volumes/Users/Library/TeX/Distributions/TeXLive-2012.texdist')
                b1bis=my_bridge('/Library/TeX/Distributions/Fink-teTeX.texdist')
                assert b1==b1bis,"#{b1}==#{b1bis} expected"
                assert b1.volume.to_s==b2.volume.to_s, "#{b1.volume} == #{b2.volume} expected"
                assert b1.domain.to_s==b2.domain.to_s, "#{b1.domain} == #{b2.domain} expected"
                assert b1.base_path.to_s<b2.base_path.to_s, "#{b1.base_path} < #{b2.base_path} expected"
                assert b1<b2,"#{b1.path} < #{b2.path} expected"
                assert b6<b7,"#{b6.path} < #{b7.path} expected"
                assert b7.volume.to_s==b8.volume.to_s, "#{b7.volume} == #{b8.volume} expected"
                assert b7.domain.to_s>b8.domain.to_s, "#{b7.domain} > #{b8.domain} expected"
                
                assert b7>b8,"#{b7.path} > #{b8.path} expected"
            end
        end
    end
end
